unit ComMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CPort, CPortCtl, Spin, ReleUnit, ComCtrls;

type
  TForm1 = class(TForm)
    ComPort: TComPort;
    Button_Open: TButton;
    Button_Settings: TButton;
    CtrlGB: TGroupBox;
    Edit_Data: TEdit;
    Button_Send: TButton;
    cmde1: TComboBox;
    Label11: TLabel;
    cmde2: TComboBox;
    chb2: TCheckBox;
    chb1: TCheckBox;
    Label12: TLabel;
    Button1: TButton;
    Button2: TButton;
    cmde3: TSpinEdit;
    Button4: TButton;
    Label13: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label14: TLabel;
    Bevel4: TBevel;
    Label15: TLabel;
    alac: TRadioButton;
    alad: TRadioButton;
    MsgR: TRichEdit;
    Label9: TLabel;
    checkb1: TCheckBox;
    Label16: TLabel;
    Label17: TLabel;
    GroupBox2: TGroupBox;
    RL1: TShape;
    RL2: TShape;
    RL3: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    IL1: TShape;
    IL2: TShape;
    IL3: TShape;
    IL4: TShape;
    IL5: TShape;
    Label6: TLabel;
    AL1: TShape;
    AL2: TShape;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    TL1: TShape;
    procedure Button_OpenClick(Sender: TObject);
    procedure Button_SettingsClick(Sender: TObject);
    procedure Button_SendClick(Sender: TObject);
    procedure ComPortOpen(Sender: TObject);
    procedure ComPortClose(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure Bt_LoadClick(Sender: TObject);
    procedure Bt_StoreClick(Sender: TObject);
    procedure UpdateDiods;
    procedure MsgRChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chb1Click(Sender: TObject);
    procedure chb2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure aladClick(Sender: TObject);
    procedure alacClick(Sender: TObject);
    procedure ComPortError(Sender: TObject; Errors: TComErrors);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;






var
  Form1: TForm1;
  Rele : TRele;
  StrBuff : string = '';

implementation

uses Math;

{$R *.DFM}



procedure TForm1.Button_OpenClick(Sender: TObject);
begin


    Rele.ConnectOnPort(Rele.ComPort.Port);


end;

procedure TForm1.Button_SettingsClick(Sender: TObject);
begin

  Rele.ShowSetupDialog;
  Button_Open.Enabled := true;

end;

procedure TForm1.Button_SendClick(Sender: TObject);
var
  Str: String;
begin
  Str := Edit_Data.Text + '#13#10';



  {SEND COMMAND}
  {}  Rele.ProcessCmd(Edit_Data.Text);

    if sender<>nil then UpdateDiods;


//  ComPort.WriteStr(Str);








end;

procedure TForm1.ComPortOpen(Sender: TObject);
begin
  Button_Open.Caption := 'Zavi port';
  MsgR.Lines.Insert(0,'COM > Port spn oteven.');
  CtrlGB.Enabled := true;


//  UpdateDiods;
end;

procedure TForm1.ComPortClose(Sender: TObject);
begin
  if Button_Open <> nil then begin
    Button_Open.Caption := 'Otevt port';
    CtrlGB.Enabled := false;

  end;
end;

procedure TForm1.ComPortRxChar(Sender: TObject; Count: Integer);
var
  Str: String;
begin
  ComPort.ReadStr(Str, Count);
  StrBuff := StrBuff + Str;

  //Ending char
  if (StrBuff<>'') and (StrBuff[Length(StrBuff)] = '*') then begin

                                Rele.ProcessRespond(StrBuff);
                                StrBuff := '';

                              end;




end;

procedure TForm1.Bt_LoadClick(Sender: TObject);
begin
  ComPort.LoadSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
//  ComPort.LoadSettings(stIniFile, 'e:\Test.ini');
end;

procedure TForm1.Bt_StoreClick(Sender: TObject);
begin
//  ComPort.StoreSettings(stIniFile, 'e:\Test.ini');
  ComPort.StoreSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\Dejan');
end;




procedure TForm1.UpdateDiods;
begin


   if Rele.Relays[1] then RL1.Brush.Color := clRed else RL1.Brush.Color := clWhite;
   if Rele.Relays[2] then RL2.Brush.Color := clRed else RL2.Brush.Color := clWhite;
   if Rele.Relays[3] then RL3.Brush.Color := clRed else RL3.Brush.Color := clWhite;

   if Rele.Inputs[1] then IL1.Brush.Color := clRed else IL1.Brush.Color := clWhite;
   if Rele.Inputs[2] then IL2.Brush.Color := clRed else IL2.Brush.Color := clWhite;
   if Rele.Inputs[3] then IL3.Brush.Color := clRed else IL3.Brush.Color := clWhite;
   if Rele.Inputs[4] then IL4.Brush.Color := clRed else IL4.Brush.Color := clWhite;
   if Rele.Inputs[5] then IL5.Brush.Color := clRed else IL5.Brush.Color := clWhite;

   if Rele.AlarmState then begin
           AL2.Brush.Color := clWhite;
           AL1.Brush.Color := clGreen;
   //        alac.Checked := true;
          end else begin
           AL2.Brush.Color := clYellow;
           AL1.Brush.Color := clWhite;
    //       alad.Checked := true;
          end;

   if Rele.AlertState then TL1.Brush.Color := clFuchsia else TL1.Brush.Color := clWhite;


end;














procedure TForm1.MsgRChange(Sender: TObject);
begin

  if Rele<>nil then UpdateDiods;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
cmd : string;
begin


       if checkb1.checked then
         Cmd := 'R'+ CMDE2.text+'='+inttostr(cmde3.value)+','+inttostr(cmde1.itemindex)+'s'
       else
         Cmd := 'R'+ CMDE2.text+'='+inttostr(cmde1.itemindex)+'s';


    {}  Rele.ProcessCmd(Cmd);
        if sender<>nil then UpdateDiods;



end;

procedure TForm1.chb1Click(Sender: TObject);
begin




    {}  Rele.CallOnTimer(chb1.Checked);
        if sender<>nil then UpdateDiods;


end;

procedure TForm1.chb2Click(Sender: TObject);
begin


    {}  Rele.CallOnInputStop(chb2.Checked);
        if sender<>nil then UpdateDiods;


end;

procedure TForm1.Button2Click(Sender: TObject);
begin

//      Edit_Data.Text:='!';
    {}  Rele.ProcessCmd('!');
        if sender<>nil then UpdateDiods;


end;

procedure TForm1.Button1Click(Sender: TObject);
begin

        Rele.ProcessCmd('?');
        if sender<>nil then UpdateDiods;


end;

procedure TForm1.aladClick(Sender: TObject);
begin


    {}  Rele.StopAlarm;
        if sender<>nil then UpdateDiods;

end;

procedure TForm1.alacClick(Sender: TObject);
begin


    {}  Rele.RunAlarm;
        if sender<>nil then UpdateDiods;

end;

procedure TForm1.ComPortError(Sender: TObject; Errors: TComErrors);
begin
  MsgR.Lines.Insert(0,'COM > Chyba v komunikaci na COM portu.');

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Rele := TRele.Create(MsgR,ComPort);
end;

end.


